﻿
init python:
    class linger_contact:
        def __init__(self, name, info, images, distance = 0, gender = "Woman", interests = "Both", chance = 100):
            self.name = name
            self.info = info
            self.images = images
            self.distance = distance
            self.gender = gender
            self.interests = interests
            self.chance = chance

    class linger_class:
        def __init__(self, dating_pool, shuffle_pool = True):
            self.dating_pool = dating_pool
            if shuffle_pool:
                random.shuffle(self.dating_pool)
            self.liked = []
            self.super_likes = []
            self.disliked = []
            self.current = None
            self.stage = "start"
            self.gender = None
            self.interests = None
            self.search_distance = 5
            self.more_info = None
            self.image_view = None
            self.current_pool = []
            self.alerts = []
            self.discarded = []
        def tick(self):
            if not len(self.liked):
                return
            random.shuffle(self.liked)
            date = self.liked.pop(0)
            chance = random.randint(0,99)
            if chance < date.chance:
                self.alerts.append(date)
                renpy.play("phone/level_up.ogg", "sfx1")
            self.discarded.append(date)
        def set_current_pool(self):
            pool = []
            for i in self.dating_pool:
                if not i in self.liked + self.disliked + self.discarded:
                    if self.interests in ["Both", i.gender]:
                        if i.interests in ["Both", self.gender]:
                            if i.distance < self.search_distance:
                                pool.append(i)
            self.current_pool = pool
        def pick(self):
            if self.current:
                return
            if len(self.current_pool) == 0:
                self.stage = "no dates"
                return
            self.current = self.current_pool.pop()
            self.stage = "playing"

        def like(self):
            if not self.current in self.liked:
                self.liked.append(self.current)
            self.current = None
            renpy.play("phone/popup.ogg", "sound")
            self.stage = "waiting"
        def super_like(self):
            if not self.current in self.super_likes:
                self.super_likes.append(self.current)
            self.current = None
            renpy.play("phone/popup.ogg", "sound")
            self.stage = "waiting"
        def dislike(self):
            if not self.current in self.disliked:
                self.disliked.append(self.current)
            self.current = None
            renpy.play("phone/godown.ogg", "sound")
            self.stage = "waiting"

        def change_stage(self, stage):
            self.stage = stage
            renpy.play("phone/rotate_up.ogg", "sound")
        def set_my_gender(self, gender):
            self.gender = gender
            self.stage = "my interest"
            renpy.play("phone/rotate_up.ogg", "sound")
        def set_my_interest(self, genders):
            self.interests = genders
            self.stage = "my distance"
            renpy.play("phone/rotate_up.ogg", "sound")
        def set_search_distance(self, distance):
            self.search_distance = distance
            self.stage = "searching"
            self.set_current_pool()
            renpy.play("phone/rotate_up.ogg", "sound")

        def set_more_info(self, date = True):
            if date:
                self.more_info = self.current
            else:
                self.more_info = None
            renpy.play("phone/rotate_up.ogg", "sound")
        def view_image(self, image):
            self.image_view = image
            renpy.play("phone/rotate_up.ogg", "sound")

        def alert_action(self, action = None):
            date = self.alerts.pop(0)
            if action:
                return [date, action]
            renpy.play("phone/rotate_up.ogg", "sound")
                




screen linger_screen(g):
    style_prefix "linger"
    frame:
        xysize 500,850 padding 0,0
        background "linger_bg"

        if g.stage == "start":
            frame:
                xfill True
                vbox:
                    text "Welcome to Linger. Your first and only option for dating."
                    button:
                        text "Set me up!"
                        action Function(g.change_stage, "my gender")
        elif g.stage == "my gender":
            frame:
                xfill True
                vbox:
                    text "I'm a..."
                    button:
                        text "Man"
                        action Function(g.set_my_gender, "Man")
                    button:
                        text "Woman"
                        action Function(g.set_my_gender, "Woman")
        elif g.stage == "my interest":
            frame:
                xfill True
                vbox:
                    text "Interested in"
                    button:
                        text "Man"
                        action Function(g.set_my_interest, "Man")
                    button:
                        text "Woman"
                        action Function(g.set_my_interest, "Woman")
                    button:
                        text "Both"
                        action Function(g.set_my_interest, "Both")
        elif g.stage == "my distance":
            frame:
                xfill True
                vbox:
                    text "Search distance."
                    vbox:
                        button:
                            text "5 kilometers"
                            action Function(g.set_search_distance, 5)
                        button:
                            text "10 kilometers"
                            action Function(g.set_search_distance, 10)
                        button:
                            text "15 kilometers"
                            action Function(g.set_search_distance, 15)
                        button:
                            text "20 kilometers"
                            action Function(g.set_search_distance, 20)
                        button:
                            text "far"
                            action Function(g.set_search_distance, 100)
        elif g.stage == "searching":
            timer random.random()+1 action Function(g.change_stage, "search result")
            frame:
                xfill True
                vbox:
                    text "searching..."
        elif g.stage == "search result":
            frame:
                xfill True
                vbox:
                    text "Found {} matches near you.".format(len(g.current_pool))
                    if len(g.current_pool):
                        button:
                            text "Alright"
                            action Function(g.change_stage, "waiting")
                    else:
                        button:
                            text "Change settings"
                            action Function(g.change_stage, "my gender")
                        button:
                            text "Close"
                            action Return("Closed")
        elif g.stage == "no dates":
            frame:
                xfill True
                vbox:
                    text "There are no more matches."
                    button:
                        text "Change settings"
                        action Function(g.change_stage, "my gender")
                    button:
                        text "Close"
                        action Return("Closed")

        elif g.stage == "waiting":
            timer 1 repeat True action Function(g.pick)
        elif g.stage == "playing":
            frame:
                padding 0,0 xysize 500,750 yalign 1.0 background None
                if g.current:
                    frame:
                        padding 0,0
                        at linger_alpha
                        add g.current.images[0] at linger_zoom(image_fit(g.current.images[0], 500, 750))
                    frame:
                        yalign 0.0 yoffset 10
                        at linger_alpha
                        text g.current.name
                    hbox:
                        yalign 1.0 yoffset -10 spacing 0
                        at linger_alpha
                        button:
                            background None padding 0,0
                            add "linger_down"
                            action Function(g.dislike)
                        button:
                            background None padding 0,0
                            add "linger_heart"
                            action Function(g.like)
                        button:
                            background None padding 0,0
                            add "linger_more"
                            action Function(g.set_more_info)

        if g.more_info:
            frame:
                padding 0,0 xysize 500,760 yalign 1.0 background "#273145ee"
                vbox:
                    spacing 10
                    text g.more_info.name size 34
                    text g.more_info.info
                    text "Distance ~{}km".format(g.more_info.distance)
                    hbox:
                        for i in g.more_info.images:
                            button:
                                padding 10,10
                                add i at linger_zoom(image_fit(g.current.images[0], 100, 100))
                                action Function(g.view_image, i)
                button:
                    yalign 1.0 yoffset -10
                    text "Close"
                    action Function(g.set_more_info, False)
        if g.image_view:
            button:
                padding 0,0 xysize 500,760 yalign 1.0 background "#273145ee"
                add g.image_view at linger_zoom(image_fit(g.image_view, 500, 750)) align .5,.5
                action Function(g.view_image, None)
        

        if len(g.alerts):
            button:
                background "#273145ee"
                action NullAction()
            frame:
                xfill True
                at linger_alpha
                vbox:
                    add g.alerts[0].images[0] at linger_zoom(image_fit(g.alerts[0].images[0], 300, 300)) align .5,.5
                    text "{} has swipped on you.".format(g.alerts[0].name)
                    button:
                        text "Send her a message"
                        action Function(g.alert_action, "message")
                    button:
                        text "Call her"
                        action Function(g.alert_action, "call")
                    button:
                        text "I've changed my mind."
                        action Function(g.alert_action)
                    # button:
                    #     text "Later."
                    #     action Function(g.alert_action, "later")


        frame:
            xfill True ysize 90 background "#273145ee" yalign 0.0
            vbox:
                text "Linger"
                text "Your only choice for dating." size 20
        # frame:
        #     xfill True ysize 90 background "#273145ee" yalign 1.0
        #     hbox:
        #         button:
        #             text "Close"
        #             action Return("Closed")
        #         button:
        #             text "Settings"
        #             action Return("Closed")






default linger = linger_class(
    [
        linger_contact("Emily", "Farm grown and farm loving.", ["emily_linger_1", "emily_linger_2", "emily_linger_3", "emily_linger_4"], 2),
        linger_contact("Jessica", "Single mom, my son is my world, you have to be a good father to my son, I don't have time for nonsense.", ["jessica_linger_1"], 3),
        linger_contact("Bethany K Murry", "Super model looking for super rich.", ["bethany_linger_1", "bethany_linger_2", "bethany_linger_3"], 5),
        linger_contact("Rei Rei", "N/A", ["reirei_linger_1"], 12),
        linger_contact("Pain magnet", "Don't swipe.", ["pain_1"], 2),
        linger_contact("Sierra", "#HealthyAtAnySize #SheThem #BodyPositivity #BeautyFull #Princess.", ["sierra_1"], 4),
        linger_contact("Penny", "The last of terran wood elves. Level 5.", ["penny_1"], 7),
        linger_contact("Krash", "Got a bike? Swipe right.", ["krash_1"], 8),
        linger_contact("Tyler", "Footbal and camping, in that order.", ["tyler_1"], 12),
        linger_contact("Sydney", "Need a builder, body and stuff.", ["sydney_1"], 6),
        linger_contact("Ava", "Fun!", ["ava_1"], 14),
        linger_contact("Becky", "Healthy body, healthy mind.", ["becky_1"], 9),
        linger_contact("Vivian", "Let's see what this is all about.", ["vivian_1"], 10),
        linger_contact("Isabella", "Stop it, I won't say it.", ["isabella_1"], 11),
        linger_contact("Hannah", "From the montains.", ["hannah_1"], 14),
        linger_contact("Madison", "Yall need to calm down, I'm not going anywhere.", ["madison_1"], 18),
        linger_contact("Luna", "I have games and anime.", ["luna_1"], 13),
        linger_contact("Sophia", "Must live in NY, no tourists.", ["sophia_1"], 13),
        linger_contact("Charlotte", "Rock roll and tatoos.", ["charlotte_1"], 20),
        linger_contact("Anna", "I'm ready to settle down, again.", ["anna_1"], 22),
        linger_contact("Mai", "We can walk, we can talk, or we can run.", ["mai_1"], 16),
        linger_contact("Elizabeth", "...", ["elizabeth_1"], 14),
    ]
    )

screen linger_ticker():
    timer random.randint(10, 30) repeat True action Function(linger.tick)
    if len(linger.alerts):
        button:
            text "You have {} alerts.".format(len(linger.alerts))

init python:
    config.overlay_screens.append("linger_ticker")


transform linger_zoom(z):
    zoom z
transform linger_alpha:
    alpha 0
    ease .2 alpha 1
style linger_frame:
    background Frame("linger_frame", 10, 10)
    padding (20,20)
    align (.5,.5)
style linger_button:
    background Frame("linger_frame", 10, 10)
    padding (20,20)
    align (.5,.5)
style linger_text:
    align (.5,.5)
    size 24
style linger_vbox:
    align (.5,.5)
    spacing 10
style linger_hbox:
    align (.5,.5)
    spacing 10




label linger_test:
    show bg park with dissolve
    call screen phone_screen(phone_class("linger_screen", [linger]))
    if _return[1] == "message":
        "The task of messaging [_return[0].name] will be delligated to your messaging system. You can use my NVL phone system for that."
    elif _return[1] == "call":
        "The task of calling [_return[0].name] will be delligated to your script."
    else:
        pass

label check_my_phone_again:
    menu:
        "Let's wait.":
            "The alerts should pile up."
        "Check my phone again.":
            call screen phone_screen(phone_class("linger_screen", [linger]))
            if _return[1] == "message":
                "The task of messaging [_return[0].name] will be delligated to your messaging system. You can use my NVL phone system for that."
            elif _return[1] == "call":
                "The task of calling [_return[0].name] will be delligated to your script."
            else:
                pass
    jump check_my_phone_again